package dao

import "time"

// UserFile 用户文件记录表
type UserFile struct {
	ID              int       `gorm:"primary_key;type:int" json:"id"`                                         //编号
	Operator        int       `gorm:"type:int" json:"operator"`                                               //操作者id
	Receiver        int       `gorm:"type:int" json:"receiver"`                                               //接收者id
	FileID          int       `gorm:"type:int" json:"fileid"`                                                 //文件id
	EffectiveDate   time.Time `gorm:"autoCreateTime;column:effectiveDate;type:datetime" json:"effectiveDate"` //阅读的有效日期
	OperationStatus string    `gorm:"type:varchar(12)" json:"operationStatus"`                                //操作状态
}

func (*UserFile) TableName() string {
	return "user_file"
}

func (uf *UserFile) BatchUFRecords(userfile []UserFile) error {
	return Db.Model(&uf).Create(&userfile).Error
}
